--Name: LucysCompass
--Author: Lucretia Valdis
--Version: 2.2
--------------------SETTINGS-VARIABLES--------------------
 LucysCompass_Plant = true
 LucysCompass_Ore = true
 LucysCompass_Wood = true
 LucysCompass_Cloth = true
 LucysCompass_Water = true
 LucysCompass_Rune = true
 LucysCompass_Treasure = true
 LucysCompass_Thievery = true
 LucysCompass_Exploration = true
 LucysCompass_RecordAll = false
 LucysCompass_nodeSize = 0.002
 LucysCompass_maxRecently = 5
 LucysCompass_IntelligentScaling = false
 
-------------------------------DATASTORING--------------------------
local firstload = true
local initialized = false
local inventoryClosed = true
local persistent = "PERSISTENT"
local currentMap = ""
local nameList = {}
local iconList = {}
local coordsX = {}
local coordsY = {}
local mapList = {}
local typeList = {}
local quickList = {}
local pointer = 0
local hidden = false
local savedVars
local atNode = false
local isTreasure = false
local isStolen = false
local recentlyGatheredX = {}
local recentlyGatheredY = {}
local recentlyX = 0
local recentlyY = 0
local recentlyPointer = 1
local recentlyType = ""
local recentlyIcon = ""
local recentlyName = ""
local offsetY = 100
local offsetX = 100
local relativePoint = 3
local MapOpen = false
local collected = false

--AccountManager
local language = "de"
local currentPlayerID = 0
local currentPlayer = ""

--Mapevaluation
local LucysCompass_mapEvaluationExpTime = 0
local LucysCompass_mapEvaluationXlocal = 0
local LucysCompass_mapEvaluationY = 0
local LucysCompass_mapEvaluationFactor = 1
local LucysCompass_mapEvaluationLogin = true
LucysCompass_mapEvaluationRevalidation = false

--Time
local arrivalTime = 0
local mapUpdateTime = 0
local loottime = 0
local targetX = 0
local targetY = 0
local startuptime = 0
local startupmessage = ""
local messageposted = false
local mapchangemessage = ""
local mapchangemessagetime = 0

--High-Level
local playerLevel = 0
local highOreList = {"calcinium", "galatite", "quicksilver", "voidstone", "kalzinium", "galatit", "flinksilber", "leerenstein"}
local highWoodList ={"birch", "ash", "mahogany", "nightwood", "birke", "esche", "mahagoni", "nachtholz"}
local highClothList = {"kreshweed","ironweed","silverweed", "void", "kresh", "eisenkraut", "silberkraut", "leeren"}
local highWaterList = {"purified","cloud","gereinigtes", "wolkennebel"}
local highLevelAdjust = 0

--Language
local langpack 
local g_mapPinManager
-------------------------------STARTUPMESSAGE--------------------------
function LucysCompass_StartupMessage()
  if (startuptime ~= nil) then
    local currtime = GetFrameTimeSeconds()
    if (currtime >= startuptime and messageposted == false) then
       CHAT_SYSTEM:AddMessage(startupmessage)
       LucysCompass_CleanUp()
        messageposted = true
    end
  end
end
--------------------------------ADDITIONALINFO--------------------------
function LucysCompass_AdditionalItemInfo(itemlink)
  for i = 0, 170 do --Iterate over Items and get their Properties
          local ESOname = "-"
          ESOname = GetItemName(1,i)
          if (string.find(itemlink, ESOname))then
            if (string.find(itemlink, "raw")) and (string.find(ESOname,"raw")) then --fix cloth issue
              if (ESOname ~= "") then
                ESOtype = GetItemType(1,i)
                ESOname = LucysCompass_HandleESONaming(ESOname)
                return ESOname, ESOtype
              end
            elseif (not string.find(itemlink, "raw")) and (not string.find(ESOname,"raw")) then --fix cloth issue
             if (ESOname ~= "") then
                ESOtype = GetItemType(1,i)
                ESOname = LucysCompass_HandleESONaming(ESOname)
                return ESOname, ESOtype
              end
            end
          end
   end
end
--------------------------------ADJUSTQUICKLIST--------------------------
function LucysCompass_AdjustQuickList()
if (pointer > 1) then
  quickList = {}
  local quickMap = GetMapName()
  local quickLink = GetMapTileTexture()
  local quickPointer = 0;
    for i = 1, (pointer-1) do
      if ((string.find(quickMap, mapList[i])) or (string.find(quickLink, mapList[i])) or ( mapList[i]==quickMap)) then
        quickList[quickPointer] = i
        quickPointer = quickPointer+1
      end
    end 
  end
end
-----------------------------------NODECHECK-----------------------------
function LucysCompass_NodeCheck(x, y, type, name)
local nS = 2*LucysCompass_getScaledProperties("node")
 if (type ~= 35) and (type ~= 37)  and (type ~= 39) then
    for i = 0, pointer do
      if ((mapList[i] == currentMap) and (typeList[i] == type) and (x > savedVars.coordsX[i]-nS) and (x < savedVars.coordsX[i]+nS) and (y > savedVars.coordsY[i]-nS) and (y < savedVars.coordsY[i]+nS)) then
      return true
      end
    end
 else
    for i = 0, pointer do
      if ((nameList[i] == name) and (mapList[i] == currentMap) and (typeList[i] == type) and (x > savedVars.coordsX[i]-nS) and (x < savedVars.coordsX[i]+nS) and (y > savedVars.coordsY[i]-nS) and (y < savedVars.coordsY[i]+nS)) then
      return true
      end
    end
 end
 return false
end
--------------------------------LEVELCHECK--------------------------
function LucysCompass_LevelCheck(type, name)
  if (type == nil) or (name == nil) then
    return false
  end
  if (type ~= 33) and (type ~= 35) and (type ~= 37)  and (type ~= 39) then
    return true
  end
  
  local iName = string.lower(name)
    if (type == 33) then --ore
    for i = 1, 4 do
      if (string.match(iName, highWaterList[i])) then
        if (playerLevel >= 50) then
          return true
        else
          return false
        end
      end
    end
  end
  if (type == 35) then --ore
    for i = 1, 8 do
      if (string.match(iName, highOreList[i])) then
        if (playerLevel >= 50) then
          return true
        else
          return false
        end
      end
    end
  end
  if (type == 37) then --wood
    for i = 1, 8 do
      if (string.match(iName, highWoodList[i])) then
        if (playerLevel >= 50) then
          return true
        else
          return false
        end
      end
    end
  end
  if (type == 39) then --cloth
    for i = 1, 8 do
      if (string.match(iName, highClothList[i])) then
        if (playerLevel >= 50) then
          return true
        else
          return false
        end
      end
    end
  end
  return true
end

function LucysCompass_IsHighLevel(name,type)
 if (type == 33) then
   for i = 1, 4 do
      if (string.match(string.lower(name), highWaterList[i])) then
      return true
      end
    end
 elseif (type == 35) then
   for i = 1, 8 do
      if (string.match(string.lower(name), highOreList[i])) then
      return true
      end
    end
 elseif (type == 37) then
   for i = 1, 8 do
      if (string.match(string.lower(name), highWoodList[i])) then
      return true
      end
    end
 elseif (type == 39) then
   for i = 1, 8 do
      if (string.match(string.lower(name), highClothList[i])) then
      return true
      end
    end
 else
    return false
 end
end
--------------------------------NAMING------------------------------
function LucysCompass_HandleESONaming(name, forced)
if (forced == nil) then
 forced = false
end
if (language == "en" and forced == false) then
  return name
elseif (language == "de" or forced) then
   if (name ~= nil) then
    local rlName = ""
        for i = 1, string.len(name) do
          local c = string.sub(name,i,i)
            if (c == "^") then
              return rlName
            else
              rlName = rlName .. c
            end
        end
    end
end
  return langpack.noname
end

---------------------------ADDING---------------------------
function LucysCompass_AddNode( _, playername, itemLink, quantity, _, type, mine)
if (hidden == false) or (hidden and LucysCompass_RecordAll)  then
  if (loottime > GetFrameTimeSeconds()) then
    if (mine) then
      if (not isTreasure) then
        local icon, _, _, _, _ = GetItemLinkInfo(itemLink)
        itemName, iT = LucysCompass_AdditionalItemInfo(itemLink)
		if (iT ~= nil) then
			if (iT == 31 and LucysCompass_Plant) or (((iT == 51) or (iT == 52) or (iT == 53)) and LucysCompass_Rune)  or (iT == 33 and LucysCompass_Water) or (iT == 35 and LucysCompass_Ore) or (iT == 37 and LucysCompass_Wood) or (iT == 39 and LucysCompass_Cloth) or (LucysCompass_RecordAll and iT > 30 and iT < 40) then
			  local playerX, playerY, walking = GetMapPlayerPosition("player")
			  if (LucysCompass_NodeCheck(playerX,playerY, iT, itemName)) then
				atNode = true
			  end
			  collected = true
							
			  if (iT == 31)then
			  recentlyType = langpack.pnode
			  elseif (iT == 51)then
			  recentlyType = langpack.rnode
			  elseif (iT == 52)then
			  recentlyType = langpack.rnode
			  elseif (iT == 53)then
			  recentlyType = langpack.rnode
			  elseif (iT == 33)then
			  recentlyType = langpack.wanode
			  elseif (iT == 35)then
			  recentlyType = langpack.onode
			  elseif (iT == 37)then
			  recentlyType = langpack.wonode
			  elseif (iT == 39)then
			  recentlyType = langpack.cnode
			  end
			  recentlyName = itemName
			  recentlyIcon = icon
			  LucysCompass_AddRecentlyGathered(playerX,playerY)
			  if (atNode == false) then
				typeList[pointer] = iT
				nameList[pointer] = itemName
				iconList[pointer] = icon
				coordsX[pointer] = playerX
				coordsY[pointer] = playerY
				mapList[pointer] = currentMap
				quickList[ (table.getn(quickList)+1) ] = pointer
				pointer = pointer + 1
				
				--Save
				
				savedVars.nameList = nameList
				savedVars.iconList = iconList
				savedVars.coordsX = coordsX
				savedVars.coordsY = coordsY
				savedVars.mapList = mapList
				savedVars.typeList = typeList
				savedVars.pointer = pointer
			 end--end AtNode         
			end--end Filter
		end
      else -- not Harvesting node, LucysCompass_Treasure
      isTreasure = false
        if (LucysCompass_Treasure) then
          local playerX, playerY, walking = GetMapPlayerPosition("player")
          if (LucysCompass_NodeCheck(playerX,playerY, 20)) then
            atNode = true
          end
          collected = true
          recentlyType = langpack.tnode
		  if (isStolen) then
          recentlyName = langpack.lchest
          recentlyIcon = "/LucysCompass/Textures/lockbox.dds"
		  else
          recentlyName = langpack.tchest
          recentlyIcon = "/LucysCompass/Textures/treasure.dds"
          end
		  LucysCompass_AddRecentlyGathered(playerX,playerY)
          if (atNode == false) then
            typeList[pointer] = 20
			if (isStolen) then
            nameList[pointer] = langpack.lchest
            iconList[pointer] = "/LucysCompass/Textures/lockbox.dds"			
			else
            nameList[pointer] = langpack.tchest
            iconList[pointer] = "/LucysCompass/Textures/treasure.dds"
            end
            coordsX[pointer] = playerX
            coordsY[pointer] = playerY
            mapList[pointer] = currentMap
            quickList[ (table.getn(quickList)+1) ] = pointer
            pointer = pointer + 1
            --Save
            
            savedVars.nameList = nameList
            savedVars.iconList = iconList
            savedVars.coordsX = coordsX
            savedVars.coordsY = coordsY
            savedVars.mapList = mapList
            savedVars.typeList = typeList
            savedVars.pointer = pointer
         end--end AtNode
        end -- end isTreasure
      end --end not Harvesting node
    end--end mine
  end
end
end

---------------------------MAIN---------------------------
function LucysCompass_GetPosition()
if  (hidden == false) or (hidden and LucysCompass_RecordAll)  then
--check Initialization
if (initialized) then
--UpdateMap while not on map
  if (not MapOpen ) and GetCurrentMapZoneIndex() ~= 38 then
    local ret = SetMapToPlayerLocation()
    if (ret == 2 ) then
      CALLBACK_MANAGER:FireCallbacks("OnWorldMapChanged")
    end
  end
--AutoHide
LucysCompass_HideGUI()
--update Map && startup message for map
if (messageposted == false) then
    LucysCompass_StartupMessage()
end
--MapUpdates
if (not MapOpen) then
  if ( GetFrameTimeSeconds() > mapUpdateTime )then
    if (currentMap ~= GetMapName()) then
      LucysCompass_AdjustQuickList()
      currentMap = GetMapName()
      mapchangemessage = langpack.map..LucysCompass_HandleESONaming(currentMap)
      mapchangemessagetime = GetFrameTimeMilliseconds()+2000
	  LucysCompass_evaluateMapSize(true)
	  LucysCompass_sortDataByMap()
    end
  end
end
--evaluate Mapsize
if (GetFrameTimeMilliseconds()>LucysCompass_mapEvaluationExpTime and  LucysCompass_mapEvaluationExpTime~= 0) then
	LucysCompass_evaluateMapSize(false)
end
if (LucysCompass_mapEvaluationFactor > 10 or (LucysCompass_mapEvaluationRevalidation and GetFrameTimeMilliseconds()>LucysCompass_mapEvaluationExpTime)) then
	LucysCompass_mapEvaluationExpTime = 0
	LucysCompass_mapEvaluationXlocal = 0
	LucysCompass_mapEvaluationY = 0
	LucysCompass_mapEvaluationFactor = 1
	LucysCompass_mapEvaluationLogin = true
	LucysCompass_evaluateMapSize(true)
end
--detect harvesting
if (GetInteractionType() == 28) then
  loottime = GetFrameTimeSeconds()+2
--detect treasures
elseif (GetInteractionType() == 20) then
  _, _, _, isStolen = GetLootTargetInfo()
  loottime = GetFrameTimeSeconds()+3
  isTreasure = true
end


local playerX, playerY, walking = GetMapPlayerPosition("player")
if (pointer > 0) then
    local currdiffX = recentlyX-playerX
    local currdiffY = recentlyY-playerY
    local currdistance = math.floor(math.sqrt(math.pow(currdiffX,2)+math.pow(currdiffY,2))*1250)
    
    if (currdistance < 1) then --at currently gathered node
      if (atNode) then --previously collected
        if (collected) then
          compass_label_name:SetText(langpack.recollect1..recentlyType..langpack.recollect2)
          compass_label_distance:SetText(recentlyName)    
          compass_item_icon:SetTexture(recentlyIcon)
          compass_direction_icon:SetTexture("/LucysCompass/Textures/logo.dds")
        else
          compass_label_name:SetText("")
          compass_item_icon:SetTexture("/LucysCompass/Textures/logo.dds")
          compass_label_distance:SetText(langpack.found)
          compass_direction_icon:SetTexture("/LucysCompass/Textures/up.dds") 
        end
      else
        if (collected) then
        compass_label_name:SetText(langpack.add1..recentlyType..langpack.add2)
        compass_label_distance:SetText(recentlyName)       
        compass_item_icon:SetTexture(recentlyIcon)
        compass_direction_icon:SetTexture("/LucysCompass/Textures/logo.dds")        
        end
      end
    else --away from it
        local tempDistance = 1000000000000
        local tempPointer = 0
        local tempDiffX = 0
        local tempDiffY = 0
        local hltempDistance = 1000000000000
        local hltempPointer = 0
        local hltempDiffX = 0
        local hltempDiffY = 0
        local tempMap = GetMapName()
        local nomaprecord = true
        for i = 0, table.getn(quickList) do
          qRef = quickList[i]
          if (tempMap == mapList[qRef] and (LucysCompass_NotInRange(coordsX[qRef],coordsY[qRef]))) then
            if (
			(typeList[qRef] == 31 and LucysCompass_Plant) or (((typeList[qRef] == 51) or (typeList[qRef] == 52) or (typeList[qRef] == 53)) and LucysCompass_Rune)  or (typeList[qRef] == 33 and LucysCompass_Water) 
			or (typeList[qRef] == 35 and LucysCompass_Ore) or (typeList[qRef] == 37 and LucysCompass_Wood) or (typeList[qRef] == 39 and LucysCompass_Cloth) or 
			(typeList[qRef] == 20 and LucysCompass_Treasure 
			and ((LucysCompass_Exploration and (nameList[qRef] == langpack.tchest)) or			(LucysCompass_Thievery and (nameList[qRef] == langpack.lchest)))
			)) 	then
				if (LucysCompass_LevelCheck(typeList[qRef], nameList[qRef])) then
                nomaprecord = false
                local diffX = coordsX[qRef]-playerX
                local diffY = coordsY[qRef]-playerY
                local distance = math.floor(math.sqrt(math.pow(diffX,2)+math.pow(diffY,2))*1250)

                if (LucysCompass_IsHighLevel(nameList[qRef],typeList[qRef])) then
                  if (distance < hltempDistance) then
                    hltempDistance = distance
                    hltempPointer = qRef
                    hltempDiffX = diffX
                    hltempDiffY = diffY
                    ignoreLast = hltempPointer
                  end
                else
                  if (distance < tempDistance) then
                    tempDistance = distance
                    tempPointer = qRef
                    tempDiffX = diffX
                    tempDiffY = diffY
                    ignoreLast = tempPointer
                  end
                end
              end
            end
          end
        end
        --choose between normal or high level
        if (hltempDistance - (LucysCompass_getScaledProperties("node")*1000)-5 < tempDistance) then
        tempDistance = hltempDistance
        tempPointer = hltempPointer
        tempDiffX = hltempDiffX
        tempDiffY = hltempDiffY
        ignoreLast = hltempPointer
        end
        
        local heading = GetPlayerCameraHeading()
        local angle = math.atan(tempDiffY/tempDiffX)
        
        if (tempDiffX)>0 then--right
          angle = math.abs(angle - 4.5)*1.04
        else--left
          angle = math.abs(angle - 1.5)*1.04
        end
        
        local currentlyfacing = math.abs(heading-angle)
        
        
        local currentlook = heading-angle
        if (angle < 1) then
          if (heading > 5.28) then
            currentlook = -(6.29-heading)
          end
        elseif (angle > 5.28) then
          if (heading < 1) then
            currentlook = heading    
          end
        end
     
       
        if (currentlyfacing>3.24) then
        currentlyfacing = math.abs(currentlyfacing-6.28)*0.8
        end
        
        if (currentlook > 0.3 and currentlook < 1) then
          compass_direction_icon:SetTexture("/LucysCompass/Textures/right.dds")
        elseif (currentlook < -0.3 and currentlook > -1) then
          compass_direction_icon:SetTexture("/LucysCompass/Textures/left.dds")
        elseif (currentlook < 0.3 and currentlook > -0.3) then
          compass_direction_icon:SetTexture("/LucysCompass/Textures/up.dds")
        else
          compass_direction_icon:SetTexture("/LucysCompass/Textures/logo.dds")    
        end
    
        if (heading > 5.28 and heading < 1) then
          compass_direction_icon:SetTexture("/LucysCompass/Textures/logo.dds")   
        end
    
        local directioninfo = LucysCompass_ColorizePercentage(langpack.distance..(LucysCompass_getScaledProperties("distance",tempDistance))..langpack.node2,(100-100*currentlyfacing))
        if (not nomaprecord) then
            if (tempDistance < (LucysCompass_getScaledProperties("node")*1000)) then
              if (atNode == false) then
                LucysCompass_AddRecentlyGathered(playerX,playerY)
              end
              atNode = true
              compass_label_distance:SetText(langpack.found)
              compass_direction_icon:SetTexture("/LucysCompass/Textures/logo.dds") 
            else
              collected = false
              atNode = false
              compass_label_distance:SetText(directioninfo)
            end
            compass_item_icon:SetTexture(iconList[tempPointer])
            compass_label_name:SetText(langpack.last..nameList[tempPointer])
        else --No Records
            compass_label_name:SetText(langpack.notenough1..LucysCompass_maxRecently..langpack.notenough2)
            compass_label_distance:SetText(LucysCompass_HandleESONaming(currentMap))    
            compass_item_icon:SetTexture("/LucysCompass/Textures/logo.dds")
            compass_direction_icon:SetTexture("/LucysCompass/Textures/up.dds")  
        end
        --MapChange message
        if (GetFrameTimeMilliseconds() < mapchangemessagetime) then
          compass_label_distance:SetText(LucysCompass_ColorizeSpecial(mapchangemessage,(math.floor((mapchangemessagetime-GetFrameTimeMilliseconds())/20))))
        end
      end
    end
  end
end
end

---------------------------LucysCompass_NotInRange-------------------------
function LucysCompass_NotInRange(x,y)
for j = 1, LucysCompass_maxRecently-1 do
  if (recentlyGatheredX[j] ~= nil) then
    if (x > (recentlyGatheredX[j]-LucysCompass_getScaledProperties("node")) and x < (recentlyGatheredX[j]+LucysCompass_getScaledProperties("node"))) then
        if (y > (recentlyGatheredY[j]-LucysCompass_getScaledProperties("node")) and y < (recentlyGatheredY[j]+LucysCompass_getScaledProperties("node"))) then
          return false
        end
    end
  end
end
return true
end
---------------------------ADDRECENTLY-------------------------
function LucysCompass_AddRecentlyGathered(x,y)
recentlyX = x
recentlyY = y
  if (recentlyPointer < LucysCompass_maxRecently)then
  recentlyGatheredX[recentlyPointer] = x
  recentlyGatheredY[recentlyPointer] = y
  recentlyPointer = recentlyPointer+1
  else
  recentlyPointer = 1 --reset pointer
  recentlyGatheredX[recentlyPointer] = x
  recentlyGatheredY[recentlyPointer] = y
  recentlyPointer = recentlyPointer+1
  end
end
---------------------------COLORIZE---------------------------
function LucysCompass_ColorizePercentage(text, percentage)
  local red = (200-(percentage*2))/100
  local green = (percentage*2)/100
  local blue = 0
  local alpha = 0.8

  if (red > 1) then
    red = 1
  elseif (red < 0) then
    red = 0
  end
  
  if (green > 1) then
    green = 1
  elseif (green < 0) then
    green = 0
  end

  local color = ZO_ColorDef:New(red,green,blue,alpha)
  text = color:Colorize(text)
  return text
end

function LucysCompass_ColorizeSpecial(text, percentage)
  percentage = percentage -  (math.floor(math.pow((percentage/10),1.2)))
  if (percentage > 100) then
  percentage = 100
  elseif (percentage < 0) then
  percentage = 0
  end
  local red = 1-0.01*percentage
  local green = 1-0.01*percentage
  local blue = 1-0.01*percentage
  local alpha = 0.8
  local color = ZO_ColorDef:New(red,green,blue,alpha)
  text = color:Colorize(text)  
  return text
end
---------------------------INITIALIZE---------------------------
function LucysCompass_InitializeGUI()
    if ( initialized == false) then
      playerLevel = GetUnitLevel("player")
      currentPlayer = GetUnitName("player")
      --set startup time and message
      language = GetCVar("language.2")
      langpack = LucysCompass_GetLanguagePackage(language)

      currentMap = GetMapName()
      startuptime = GetFrameTimeSeconds()+1
      --load variables
      savedVars = ZO_SavedVars:NewAccountWide("LucysCompass_SV", 1, nil, defaults)
      
      if (savedVars.firstload == false) then
      firstload = savedVars.firstload
      end
                  
      if (firstload == false) then   
      LucysCompass_PatchData()
      nameList = savedVars.nameList
      iconList = savedVars.iconList
      coordsX = savedVars.coordsX
      coordsY = savedVars.coordsY
      mapList = savedVars.mapList
      typeList = savedVars.typeList
      pointer = savedVars.pointer
      
        if (savedVars.offsetX ~= nil) then      
          relativePoint = savedVars.relativePoint 
          offsetX = savedVars.offsetX  
          offsetY = savedVars.offsetY   
        end
        --init usertable
        if (savedVars.user == nil or table.getn(savedVars.user) == 0) then
            savedVars.user = user
            savedVars.userplant = {}
            savedVars.userore = {}
            savedVars.userwood = {}
            savedVars.usercloth = {}
            savedVars.userwater = {}
            savedVars.userrune = {}
            savedVars.usertreasure = {}
            
            savedVars.user[1] = currentPlayer
            savedVars.userplant[1] = LucysCompass_Plant
            savedVars.userore[1] = LucysCompass_Ore
            savedVars.userwood[1] = LucysCompass_Wood
            savedVars.usercloth[1] = LucysCompass_Cloth
            savedVars.userwater[1] = LucysCompass_Water
            savedVars.userrune[1] = LucysCompass_Rune
            savedVars.usertreasure[1] = LucysCompass_Treasure
            savedVars.recordall[1] = LucysCompass_RecordAll
            savedVars.thievery[1] = LucysCompass_Thievery
            savedVars.exploration[1] = LucysCompass_Exploration
            savedVars.intelligentscaling[1] = LucysCompass_IntelligentScaling
            savedVars.nodesize[1] = LucysCompass_nodeSize
            savedVars.maxrecently[1] = LucysCompass_maxRecently
        else
          local foundplayer = false
          --search player in database
          for i = 1, (table.getn(savedVars.user)) do
            if (savedVars.user[i] == currentPlayer) then
               currentPlayerID = i 
               LucysCompass_Plant = savedVars.userplant[i]
               LucysCompass_Ore  = savedVars.userore[i]
               LucysCompass_Wood = savedVars.userwood[i]
               LucysCompass_Cloth  = savedVars.usercloth[i]
               LucysCompass_Water  = savedVars.userwater[i]
               LucysCompass_Rune  = savedVars.userrune[i]
               LucysCompass_PatchDataEntries(i)
               foundplayer = true
               startupmessage = langpack.startup11..savedVars.user[i]..langpack.startup12
            end
          end
          --create new player
          if (foundplayer == false) then
            local playeramount = (table.getn(savedVars.user))+1
            currentPlayerID = playeramount
            savedVars.nodesize[playeramount] = LucysCompass_nodeSize
            savedVars.user[playeramount] = currentPlayer
            savedVars.userplant[playeramount] = LucysCompass_Plant
            savedVars.userore[playeramount] = LucysCompass_Ore
            savedVars.userwood[playeramount] = LucysCompass_Wood
            savedVars.usercloth[playeramount] = LucysCompass_Cloth
            savedVars.userwater[playeramount] = LucysCompass_Water
            savedVars.userrune[playeramount] = LucysCompass_Rune
            savedVars.usertreasure[playeramount] = LucysCompass_Treasure
            savedVars.recordall[playeramount] = LucysCompass_RecordAll
            savedVars.thievery[playeramount] = LucysCompass_Thievery
            savedVars.exploration[playeramount] = LucysCompass_Exploration
            savedVars.intelligentscaling[playeramount] = LucysCompass_IntelligentScaling
            startupmessage = langpack.startup0..savedVars.user[playeramount]..", ID: "..playeramount.."."
          end
        end
      
      else
      savedVars.nameList = nameList
      savedVars.iconList = iconList
      savedVars.coordsX = coordsX
      savedVars.coordsY = coordsY
      savedVars.mapList = mapList
      savedVars.typeList = typeList
      savedVars.pointer = pointer    
      
      savedVars.user = {}
      savedVars.userplant = {}
      savedVars.userore = {}
      savedVars.userwood = {}
      savedVars.usercloth = {}
      savedVars.userwater = {}
      savedVars.userrune = {}
      savedVars.usertreasure = {}
      savedVars.nodesize = {}
      savedVars.recordall = {}
      savedVars.thievery = {}
      savedVars.exploration = {}
      savedVars.intelligentscaling = {}
      savedVars.maxrecently = {}  
      savedVars.user[1] = currentPlayer
      savedVars.userplant[1] = LucysCompass_Plant
      savedVars.userore[1] = LucysCompass_Ore
      savedVars.userwood[1] = LucysCompass_Wood
      savedVars.usercloth[1] = LucysCompass_Cloth
      savedVars.userwater[1] = LucysCompass_Water
      savedVars.userrune[1] = LucysCompass_Rune
      savedVars.usertreasure[1] = LucysCompass_Treasure
      savedVars.nodesize[1] = LucysCompass_nodeSize      
      savedVars.recordall[1] = LucysCompass_RecordAll
      savedVars.thievery[1] = LucysCompass_Thievery
      savedVars.exploration[1] = LucysCompass_Exploration
      savedVars.intelligentscaling[1] = LucysCompass_IntelligentScaling
      savedVars.maxrecently[1] = LucysCompass_maxRecently
      currentUserID = 1
      firstload = false
      savedVars.firstload = firstload
      end


    
      --create updater
      local updater = WINDOW_MANAGER:CreateControlFromVirtual("updater", GuiRoot, "ZO_EditBackdrop")
      updater:SetHandler("OnUpdate", LucysCompass_GetPosition)
            
      --create window
      local window = WINDOW_MANAGER:CreateTopLevelWindow( "compass" ) 
      compass:SetDimensions(300, 110)
      compass:SetAnchor(relativePoint, GuiRoot, relativePoint, offsetX, offsetY)
      compass:SetHidden( false )
      compass:SetMovable( true )
      compass:SetMouseEnabled( true )
      compass:SetHandler("OnMoveStop", LucysCompass_Relocated)
    
      local bg = WINDOW_MANAGER:CreateControl( "compass_bg",  compass, CT_BACKDROP)
      compass_bg:SetAnchor(CENTER, compass, CENTER, 0, 0)
      compass_bg:SetAnchorFill(compass)
      compass_bg:SetCenterColor( 0,0,0,.4 )
      compass_bg:SetEdgeColor( 0,0,0,100 )
      compass_bg:SetEdgeTexture("",8,1,2)    
      
      
      local icon = WINDOW_MANAGER:CreateControl( "compass_direction_icon", compass, CT_TEXTURE)
      compass_direction_icon:SetDimensions(40 , 40)
      compass_direction_icon:SetAnchor(CENTER, compass, CENTER, 0, -65)
      compass_direction_icon:SetTexture("/LucysCompass/Textures/up.dds")
  
      local label = WINDOW_MANAGER:CreateControl( "compass_label_distance", compass, CT_LABEL)
      compass_label_distance:SetAnchor(CENTER, compass, CENTER, 0, -35)
      compass_label_distance:SetFont("ZoFontGame")
      compass_label_distance:SetColor( 1,1,1,1 )
      compass_label_distance:SetHorizontalAlignment( CENTER )
      compass_label_distance:SetVerticalAlignment( CENTER )
      compass_label_distance:SetText ( "" )
      
      
      local icon = WINDOW_MANAGER:CreateControl( "compass_item_icon", compass, CT_TEXTURE)
      compass_item_icon:SetDimensions(40 , 40)
      compass_item_icon:SetAnchor(CENTER, compass, CENTER, 0, 0)
      compass_item_icon:SetTexture("/LucysCompass/Textures/logo.dds")
      
      local label = WINDOW_MANAGER:CreateControl( "compass_label_name", compass, CT_LABEL)
      compass_label_name:SetAnchor(CENTER, compass,CENTER, 0, 35)
      compass_label_name:SetFont("ZoFontGame")
      compass_label_name:SetColor( 1,1,1,1 )
      compass_label_name:SetHorizontalAlignment( CENTER )
      compass_label_name:SetVerticalAlignment( CENTER )
      compass_label_name:SetText ( "" )
      
    initialized = true
    LucysCompass_CreateSettings()
    LucysCompass_AdjustQuickList()
	LucysCompass_evaluateMapSize(true)
  end
  
end

---------------------------UPGRADE---------------------------
function LucysCompass_PatchData()
 --Creation for Adding new Parameters on Updates
      --1.6
      if (savedVars.usertreasure == nil) then
      savedVars.usertreasure = {}
      end
      --1.7   
      if (savedVars.nodesize == nil) then
      savedVars.nodesize = {}
      end
      if (savedVars.recordall == nil) then
      savedVars.recordall = {}
      end
      --2.1
      if (savedVars.maxrecently == nil) then
      savedVars.maxrecently = {}
      end	
	  --3.0
      if (savedVars.thievery == nil) then
      savedVars.thievery = {}
      end
      if (savedVars.exploration == nil) then
      savedVars.exploration = {}
      end
      if (savedVars.intelligentscaling == nil) then
      savedVars.intelligentscaling = {}
      end
--end of Update
end


function LucysCompass_PatchDataEntries(playerID)
 --Creation for Adding new Parameters on Updates
      --1.6
      if (savedVars.usertreasure[playerID] == nil) then
               savedVars.usertreasure[playerID] = LucysCompass_Treasure
      else
               LucysCompass_Treasure = savedVars.usertreasure[playerID]
      end
      --1.7
      if (savedVars.nodesize[playerID] == nil) then      
               savedVars.nodesize[playerID] = LucysCompass_nodeSize
      else      
               LucysCompass_nodeSize = savedVars.nodesize[playerID]
      end
      if (savedVars.recordall[playerID] == nil) then      
               savedVars.recordall[playerID] = LucysCompass_RecordAll
      else      
               LucysCompass_RecordAll = savedVars.recordall[playerID]
      end
      --2.1
      if (savedVars.maxrecently[playerID] == nil) then      
               savedVars.maxrecently[playerID] = LucysCompass_maxRecently
      else      
               LucysCompass_maxRecently = savedVars.maxrecently[playerID]
      end
	  --3.0
	  if (savedVars.thievery[playerID] == nil) then      
               savedVars.thievery[playerID] = LucysCompass_Thievery
      else      
               LucysCompass_Thievery = savedVars.thievery[playerID]
      end
	  if (savedVars.exploration[playerID] == nil) then      
               savedVars.exploration[playerID] = LucysCompass_Exploration
      else      
               LucysCompass_Exploration = savedVars.exploration[playerID]
      end
	  if (savedVars.intelligentscaling[playerID] == nil) then      
               savedVars.intelligentscaling[playerID] = LucysCompass_IntelligentScaling
      else      
               LucysCompass_IntelligentScaling = savedVars.intelligentscaling[playerID]
      end
--end of Update
end
---------------------------SETTINGS---------------------------
function LucysCompass_CreateSettings()
		LucysCompass_installSettings(langpack)
end


---------------------------COMMANDS---------------------------

function LucysCompass_RevertAll()
 LucysCompass_Plant = true
 LucysCompass_Ore = true
 LucysCompass_Wood = true
 LucysCompass_Cloth = true
 LucysCompass_Water = true
 LucysCompass_Rune = true
 LucysCompass_Treasure = true
 LucysCompass_RecordAll = false
 LucysCompass_Thievery = true
 LucysCompass_Exploration = true
 LucysCompass_IntelligentScaling = false
 LucysCompass_nodeSize = 0.002
 LucysCompass_maxRecently = 5
 
savedVars.userplant[currentPlayerID] = LucysCompass_Plant
savedVars.userore[currentPlayerID] = LucysCompass_Ore
savedVars.userwood[currentPlayerID] = LucysCompass_Wood
savedVars.usercloth[currentPlayerID] = LucysCompass_Cloth
savedVars.userwater[currentPlayerID] = LucysCompass_Water
savedVars.userrune[currentPlayerID] = LucysCompass_Rune
savedVars.usertreasure[currentPlayerID] = LucysCompass_Treasure
savedVars.recordall[currentPlayerID] = LucysCompass_RecordAll
savedVars.thievery[currentPlayerID] = LucysCompass_Thievery
savedVars.exploration[currentPlayerID] = LucysCompass_Exploration
savedVars.intelligentscaling[currentPlayerID] = LucysCompass_IntelligentScaling
savedVars.nodesize[currentPlayerID] = LucysCompass_nodeSize
savedVars.maxrecently[currentPlayerID] = LucysCompass_maxRecently
ReloadUI()
CHAT_SYSTEM:AddMessage(langpack.reset)
end

function LucysCompass_DeleteAll()
        --Erase
        nameList = {}
        iconList = {}
        coordsX = {}
        coordsY = {}
        mapList = {}
        typeList = {}
        pointer = 0
        
        --Delete        
       savedVars.nameList = nameList
       savedVars.iconList = iconList
       savedVars.coordsX = coordsX
       savedVars.coordsY = coordsY
       savedVars.mapList = mapList
       savedVars.typeList = typeList
       savedVars.pointer = pointer
       
       --Reset      
        compass_label_name:SetText("")
        compass_label_distance:SetText("")    
        compass_item_icon:SetTexture("/LucysCompass/Textures/logo.dds")
        compass_direction_icon:SetTexture("/LucysCompass/Textures/up.dds")  
        CHAT_SYSTEM:AddMessage(langpack.deleteall)
end


---------------------------DATA EVALUATION---------------------------
function LucysCompass_getUserData()
	text = ""
    for i = 1, (table.getn(savedVars.user)) do
      local message = LucysCompass_formatStringLucyStyle(savedVars.user[i])..langpack.searchfor
        if (savedVars.userplant[i]) then
        message = message .. LucysCompass_colorResources("plant",langpack.plant)..", "
        end
        if (savedVars.userwater[i]) then
        message = message .. LucysCompass_colorResources("water",langpack.water)..", "
        end
        if (savedVars.userrune[i]) then
        message = message .. LucysCompass_colorResources("rune",langpack.rune)..", "
        end
        if (savedVars.userwood[i]) then
        message = message .. LucysCompass_colorResources("wood",langpack.wood)..", "
        end
        if (savedVars.userore[i]) then
        message = message .. LucysCompass_colorResources("ore",langpack.ore)..", "
        end
        if (savedVars.usercloth[i]) then
        message = message .. LucysCompass_colorResources("cloth",langpack.cloth)..", "
        end
        if (savedVars.usertreasure[i]) then
        message = message .. LucysCompass_colorResources("treasure",langpack.treasure)..", "
        end
        message = string.sub(message,0,-3)
        text = text..message.."\n"
    end
	return math.floor(table.getn(savedVars.user)/3+0.5),text
end
function LucysCompass_getGatheringData()

local PlantAmount = 0
local RuneAmount = 0
local WaterAmount = 0
local OreAmount = 0
local WoodAmount = 0
local ClothAmount = 0
local TreasureAmount = 0

for i = 0, (pointer-1) do
  if (typeList[i] == 31) then
    PlantAmount = PlantAmount +1
  elseif ((typeList[i] == 51) or (typeList[i] == 52) or (typeList[i] == 53)) then
    RuneAmount = RuneAmount +1
  elseif (typeList[i] == 33) then
    WaterAmount = WaterAmount +1
  elseif (typeList[i] == 35) then
    OreAmount = OreAmount +1
  elseif (typeList[i] == 37) then
    WoodAmount = WoodAmount +1
  elseif (typeList[i] == 39) then
    ClothAmount = ClothAmount +1  
  elseif (typeList[i] == 20) then
    TreasureAmount = TreasureAmount +1
  end
end

text = ""..LucysCompass_colorResources("plant",langpack.plant)..langpack.recorded..PlantAmount..".\n"
..LucysCompass_colorResources("water",langpack.water)..langpack.recorded..WaterAmount..".\n"
..LucysCompass_colorResources("rune",langpack.rune)..langpack.recorded..RuneAmount..".\n"
..LucysCompass_colorResources("wood",langpack.wood)..langpack.recorded..WoodAmount..".\n"
..LucysCompass_colorResources("ore",langpack.ore)..langpack.recorded..OreAmount..".\n"
..LucysCompass_colorResources("cloth",langpack.cloth)..langpack.recorded..ClothAmount..".\n"
..LucysCompass_colorResources("treasure",langpack.treasure)..langpack.recorded..TreasureAmount..".\n"
.."Total : "..(PlantAmount+RuneAmount+WaterAmount+OreAmount+WoodAmount+ClothAmount+TreasureAmount)..".\n"
return 1,text
end

function LucysCompass_sortDataByMap()
if (table.getn(mapList) == 0) then
mapTexts = {}
mapTexts[1] = {}
mapTexts[1].title = ""
mapTexts[1].text = ""
return 1, mapTexts
end
mapNameTable = {}
mapTable ={}
	for i=0, #mapList do
		if (mapTable[mapList[i]]== nil) then
			mapTable[mapList[i]] = {}
			mapTable[mapList[i]].count = 1
			mapTable[mapList[i]].plant = 0
			mapTable[mapList[i]].ore = 0
			mapTable[mapList[i]].wood = 0
			mapTable[mapList[i]].cloth = 0
			mapTable[mapList[i]].water = 0
			mapTable[mapList[i]].rune = 0
			mapTable[mapList[i]].treasure = 0
			mapNameTable[table.getn(mapNameTable)+1] = mapList[i]
		else 
			mapTable[mapList[i]].count = mapTable[mapList[i]].count+1
		end
		if (typeList[i] == 31)then
			mapTable[mapList[i]].plant = mapTable[mapList[i]].plant + 1
		elseif (typeList[i] == 51)then
			mapTable[mapList[i]].rune = mapTable[mapList[i]].rune + 1
		elseif (typeList[i] == 52)then
			mapTable[mapList[i]].rune = mapTable[mapList[i]].rune + 1
		elseif (typeList[i] == 53)then
			mapTable[mapList[i]].rune = mapTable[mapList[i]].rune + 1
		elseif (typeList[i] == 33)then
			mapTable[mapList[i]].water = mapTable[mapList[i]].water + 1
		elseif (typeList[i] == 35)then
			mapTable[mapList[i]].ore = mapTable[mapList[i]].ore + 1
		elseif (typeList[i] == 37)then
			mapTable[mapList[i]].wood = mapTable[mapList[i]].wood + 1
		elseif (typeList[i] == 39)then
			mapTable[mapList[i]].cloth = mapTable[mapList[i]].cloth + 1
		elseif (typeList[i] == 20)then
			mapTable[mapList[i]].treasure = mapTable[mapList[i]].treasure + 1
		end
	end
mapTable, mapNameTable = LucysCompass_sortToNumber(mapTable, mapNameTable)
linebreaks = 0
mapTexts = {}
	for i=1, #mapNameTable do
		mapTextTitle = LucysCompass_formatStringLucyStyle(LucysCompass_HandleESONaming(LucysCompass_replaceUmlaut(mapNameTable[i]),true))..": "..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].count,mapTable[mapNameTable[i]].count).."\n"
		mapTextContent = LucysCompass_colorResources("plant",langpack.plant_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].plant,mapTable[mapNameTable[i]].plant*7)..",    "..
		LucysCompass_colorResources("water",langpack.water_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].water,mapTable[mapNameTable[i]].water*7).. ",    "..
		LucysCompass_colorResources("rune",langpack.rune_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].rune,mapTable[mapNameTable[i]].rune*7).. ",    "..
		LucysCompass_colorResources("wood",langpack.wood_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].wood,mapTable[mapNameTable[i]].wood*7).. ",    "..
		LucysCompass_colorResources("ore",langpack.ore_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].ore,mapTable[mapNameTable[i]].ore*7).. ",    "..
		LucysCompass_colorResources("cloth",langpack.cloth_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].cloth,mapTable[mapNameTable[i]].cloth*7).. ",    "..
		LucysCompass_colorResources("treasure",langpack.treasure_s..": ")..LucysCompass_ColorizePercentage(mapTable[mapNameTable[i]].treasure,mapTable[mapNameTable[i]].treasure*7)
		linebreaks = linebreaks+1
		mapTexts[linebreaks] = {}
		mapTexts[linebreaks].title = mapTextTitle
		mapTexts[linebreaks].text = mapTextContent
	end
return linebreaks, mapTexts
end

function LucysCompass_sortToNumber(mapList, mapNameList)
if (mapList == nil or table.getn(mapNameList) < 2) then
	return mapList, mapNameList
end

sorted = false
for i=1, #mapNameList do
	if (mapNameList[i+1] ~= nil) then
		if (mapList[mapNameList[i]].count < mapList[mapNameList[i+1]].count) then
			higherMapName = mapNameList[i]
			lowerMapName = mapNameList[i+1]
			mapNameList[i] = lowerMapName
			mapNameList[i+1] = higherMapName
			sorted = true
		end	
	end
end
if (sorted) then
mapList,mapNameList = LucysCompass_sortToNumber(mapList, mapNameList)
end
return mapList,mapNameList
end

function LucysCompass_replaceUmlaut(str)
   str = string.gsub(str,"ä", "ae")
   str = string.gsub(str,"ö", "oe")
   str = string.gsub(str,"ü", "ue")
   str = string.gsub(str,"Ä", "Ae")
   str = string.gsub(str,"Ö", "Oe")
   str = string.gsub(str,"Ü", "Ue")
   return str
end

function LucysCompass_colorResources(type, name)
	if (type == "plant") then
	return "|c38B55B"..name.."|r"
	elseif (type == "ore") then
	return "|c999999"..name.."|r"
	elseif (type == "wood") then
	return "|c7C563D"..name.."|r"
	elseif (type == "cloth") then
	return "|cFFE97F"..name.."|r"
	elseif (type == "water") then
	return "|c5BC0FF"..name.."|r"
	elseif (type == "rune") then
	return "|cA46CB2"..name.."|r"
	elseif (type == "treasure") then
	return "|cFFCC00"..name.."|r" 
	else
	return "|c551A8B"..name.."|r"
	end
end

function LucysCompass_formatStringLucyStyle(name)
userName = ""
l = LucysCompass_splitText(name)
	for i=1, #l do
		lit = "|c551A8B"..string.sub(l[i],0,1).."|r"
		fol = "|c9975B9"..string.sub(l[i],2).."|r "
		userName = userName..lit..fol
	end
return userName
end

function LucysCompass_splitText(name)
nameParts = {}
for namePart in name:gmatch("%w+") do table.insert(nameParts, namePart) end
return nameParts
end

function LucysCompass_BoolToString(b)
if (b) then
	return "True"
else
	return "False"
end
end
---------------------------TOGGLES---------------------------

function LucysCompass_SetRecently(ignore)
LucysCompass_maxRecently = ignore
savedVars.maxrecently[currentPlayerID] = LucysCompass_maxRecently
end
function LucysCompass_SetNodeSize(size)
LucysCompass_nodeSize = size/1000
savedVars.nodesize[currentPlayerID] = LucysCompass_nodeSize
end

function LucysCompass_RecordAll()
  if (LucysCompass_RecordAll) then
    LucysCompass_RecordAll = false
  else
    LucysCompass_RecordAll = true
  end
  savedVars.recordall[currentPlayerID] = LucysCompass_RecordAll
end

function LucysCompass_ToggleHide()
if (hidden) then
  compass:SetHidden( false)
  hidden = false
  else
  compass:SetHidden( true)
  hidden = true
  end
end

function LucysCompass_TogglePlant()
  if (LucysCompass_Plant) then
   LucysCompass_Plant = false
  else
    LucysCompass_Plant = true
  end
  savedVars.userplant[currentPlayerID] = LucysCompass_Plant
end

function LucysCompass_ToggleOre()
  if (LucysCompass_Ore) then
   LucysCompass_Ore = false
  else
    LucysCompass_Ore = true
  end
  savedVars.userore[currentPlayerID] = LucysCompass_Ore
end

function LucysCompass_ToggleWood()
  if (LucysCompass_Wood) then
   LucysCompass_Wood = false
  else
    LucysCompass_Wood = true
  end
  savedVars.userwood[currentPlayerID] = LucysCompass_Wood
end

function LucysCompass_ToggleCloth()
  if (LucysCompass_Cloth) then
   LucysCompass_Cloth = false
  else
    LucysCompass_Cloth = true
  end
  savedVars.usercloth[currentPlayerID] = LucysCompass_Cloth
end

function LucysCompass_ToggleWater()
  if (LucysCompass_Water) then
   LucysCompass_Water = false
  else
    LucysCompass_Water = true
  end
  savedVars.userwater[currentPlayerID] = LucysCompass_Water
end

function LucysCompass_ToggleRune()
  if (LucysCompass_Rune) then
   LucysCompass_Rune = false
  else
    LucysCompass_Rune = true
  end
  savedVars.userrune[currentPlayerID] = LucysCompass_Rune
end

function LucysCompass_ToggleTreasure()
  if (LucysCompass_Treasure) then
   LucysCompass_Treasure = false
  else
    LucysCompass_Treasure = true
  end
  savedVars.usertreasure[currentPlayerID] = LucysCompass_Treasure
end

function LucysCompass_toggleThievery()
  if (LucysCompass_Thievery) then
    LucysCompass_Thievery = false
  else
    LucysCompass_Thievery = true
  end
 savedVars.thievery[currentPlayerID] = LucysCompass_Thievery
end

function LucysCompass_toggleExploration()
  if (LucysCompass_Exploration) then
    LucysCompass_Exploration = false
  else
    LucysCompass_Exploration = true
  end
 savedVars.exploration[currentPlayerID] = LucysCompass_Exploration
end

function LucysCompass_toggleIntelligentScaling()
  if (LucysCompass_IntelligentScaling) then
    LucysCompass_IntelligentScaling = false
  else
    LucysCompass_IntelligentScaling = true
  end
 savedVars.intelligentscaling[currentPlayerID] = LucysCompass_IntelligentScaling
end

---------------------------CLEANING---------------------------
function LucysCompass_CleanUp()
local deleted = 0
  for k = 0, (pointer-1) do
    local current_x = coordsX[k]
    local current_y = coordsY[k]
    local current_map = mapList[k]
    local current_type = typeList[k]
    local current_name = nameList[k]
    if (current_type ~= 35) and (current_type ~= 37) and (current_type ~= 39) then
      for i = 0, (pointer-1) do
        if (k ~= i) and (nameList[i] ~= nil) then
          if (current_map == mapList[i]) and (current_type == typeList[i]) then
            if (current_x > coordsX[i]-LucysCompass_nodeSize) and (current_x < coordsX[i]+LucysCompass_nodeSize) then
              if (current_y > coordsY[i]-LucysCompass_nodeSize) and (current_y < coordsY[i]+LucysCompass_nodeSize) then
                table.remove(nameList, k)
                table.remove(iconList, k)
                table.remove(coordsX, k)
                table.remove(coordsY, k)
                table.remove(mapList, k)
                table.remove(typeList, k)
                deleted = deleted + 1
              end
            end
          end
        end
      end
    else -- ores, woods, cloth
      for i = 0, (pointer-1) do
        if (k ~= i) and (nameList[i] ~= nil) then
          if (current_map == mapList[i]) and (current_type == typeList[i])  and (current_name == nameList[i]) then
            if (current_x > coordsX[i]-LucysCompass_nodeSize) and (current_x < coordsX[i]+LucysCompass_nodeSize) then
              if (current_y > coordsY[i]-LucysCompass_nodeSize) and (current_y < coordsY[i]+LucysCompass_nodeSize) then
                table.remove(nameList, k)
                table.remove(iconList, k)
                table.remove(coordsX, k)
                table.remove(coordsY, k)
                table.remove(mapList, k)
                table.remove(typeList, k)
                deleted = deleted + 1
              end
            end
          end
        end
      end
    end
  end
  pointer = pointer - deleted
  trashRemoved = 0
  for r = 0, (pointer-1) do
    if (typeList[r] == 10 or typeList[r] == 16 ) then
      table.remove(nameList, r)
      table.remove(iconList, r)
      table.remove(coordsX, r)
      table.remove(coordsY, r)
      table.remove(mapList, r)
      table.remove(typeList, r)
      trashRemoved = trashRemoved + 1
    end
  end
  pointer = pointer - trashRemoved
  savedVars.nameList = nameList
  savedVars.iconList = iconList
  savedVars.coordsX = coordsX
  savedVars.coordsY = coordsY
  savedVars.mapList = mapList
  savedVars.typeList = typeList
  savedVars.pointer = pointer
  if ((deleted+trashRemoved) ~= 0) then
    CHAT_SYSTEM:AddMessage((deleted+trashRemoved)..langpack.redundant)
  else
    CHAT_SYSTEM:AddMessage(langpack.noredundant)  
  end
end


---------------------------GUI HANDLING---------------------------
function LucysCompass_Relocated()
  local isValidAnchor, _, _, rP, osX, osY = compass:GetAnchor(0)
  -- relativePoint
  -- 3    9
  ------------
  -- 6    12  
  if (isValidAnchor) then    
    savedVars.relativeAnchor  = relativeTo
    savedVars.relativePoint   = rP    
    savedVars.point           = point    
    savedVars.offsetX         = osX
    savedVars.offsetY         = osY
  end
end

function LucysCompass_InventoryHandler( eventCode,  layerIndex,  activeLayerIndex)
if (eventCode == 65551 and layerIndex == 3 and activeLayerIndex == 2) then
inventoryClosed = true --inventory
elseif (eventCode == 65550 and layerIndex == 3 and activeLayerIndex == 3) then
inventoryClosed = false --inventory
elseif (eventCode == 65551 and layerIndex == 5 and activeLayerIndex == 3) then
inventoryClosed = true --map teleport
end
end
function LucysCompass_HideGUI()
  if not hidden then
    menu1 = ZO_GameMenu_InGame:IsHidden()
    menu2 = inventoryClosed
    menu3 = ZO_InteractWindow:IsHidden()
    menu4 = ZO_Character:IsHidden()
    infight = IsUnitInCombat("player")
    
    if not menu1 or not menu2 or not menu3 or not menu4 or infight
    then
      compass:SetHidden(true)
      MapOpen = true
    else
      compass:SetHidden(false)
      if (MapOpen) then
        mapUpdateTime = GetFrameTimeSeconds()+1
        MapOpen = false
      end
    end
  end
end

---------------------------SCALING---------------------------
function LucysCompass_evaluateMapSize(planFutureInspect)
	if (planFutureInspect) then
		LucysCompass_mapEvaluationExpTime = GetFrameTimeMilliseconds()+1000
		LucysCompass_mapEvaluationX, LucysCompass_mapEvaluationY,_ = GetMapPlayerPosition("player")
	else
		local lc_mapMovedX, lc_mapMovedY,_ = GetMapPlayerPosition("player")
		local lc_mapXdiff = LucysCompass_mapEvaluationX-lc_mapMovedX
		local lc_mapYdiff = LucysCompass_mapEvaluationY-lc_mapMovedY
		local walkedDist = math.floor(math.sqrt(math.pow(lc_mapXdiff,2)+math.pow(lc_mapYdiff,2))*1250)
		
		if (IsMounted()) then
		walkedDist = walkedDist*0.75
		end
		--on login set up future evaluation plan
		local lastCheck = false
		if (LucysCompass_mapEvaluationLogin or LucysCompass_mapEvaluationRevalidation) then
			LucysCompass_mapEvaluationRevalidation = false
			if (walkedDist == 0) then
				LucysCompass_evaluateMapSize(true)
			else
				LucysCompass_mapEvaluationLogin = false
				lastCheck = true
				LucysCompass_evaluateMapSize(true)
			end
		end
		if (walkedDist == 0) then
			walkedDist = 10
			LucysCompass_mapEvaluationRevalidation = true
		end
		LucysCompass_mapEvaluationFactor = math.ceil(walkedDist/10,0)
		if (LucysCompass_mapEvaluationLogin == false and lastCheck == false) then
			LucysCompass_mapEvaluationExpTime = 0
		end
		
	end
end

function LucysCompass_getScaledProperties(name, tempDistance)
	if (name == "node") then
		if (LucysCompass_IntelligentScaling) then
			return (LucysCompass_nodeSize+((LucysCompass_mapEvaluationFactor-1)/1000))
		else
			return LucysCompass_nodeSize
		end
	elseif (name == "distance") then
		if (LucysCompass_IntelligentScaling) then
			return math.floor((tempDistance-LucysCompass_getScaledProperties("node")*1000)/LucysCompass_mapEvaluationFactor)	
		else
			return (tempDistance-LucysCompass_getScaledProperties("node")*1000)
		end
	end
end

---------------------------FUTURE IMPLEMENTATIONS---------------------------
function LucysCompass_deleteSelectedProfile(name)
	savedVars = ZO_SavedVars:NewAccountWide("LucysCompass_SV", 1, nil, defaults)
	if (savedVars.user ~= nil and table.getn(savedVars.user) > 0) then
		for i = 1, (table.getn(savedVars.user)) do
			if (savedVars.user[i] == name) then
			
			end
		end
	end
end
---------------------------REGISTRATION---------------------------
SLASH_COMMANDS["/lcdeleteall"] = LucysCompass_DeleteAll


EVENT_MANAGER:RegisterForEvent( "LucysCompass" , EVENT_LOOT_RECEIVED , LucysCompass_AddNode )
EVENT_MANAGER:RegisterForEvent( "LucysCompass" , EVENT_ADD_ON_LOADED , LucysCompass_InitializeGUI )
EVENT_MANAGER:RegisterForEvent( "LucysCompass" , EVENT_ACTION_LAYER_POPPED, LucysCompass_InventoryHandler )
EVENT_MANAGER:RegisterForEvent( "LucysCompass" , EVENT_ACTION_LAYER_PUSHED, LucysCompass_InventoryHandler )