--Settings
--Panel
function LucysCompass_installSettings(langpack)

local panel_settings = {
	type = "panel",
	name = "LucysCompass",
	displayName = "|c551A8BL|r|c9975B9ucys|r|c551A8BC|r|c9975B9ompass|r 3.0r",
	author = "|c551A8BL|r|c9975B9ucretia|r|c551A8BV|r|c9975B9aldis|r",
	version = "3.0r",
	slashCommand = "/lcsettings",
	registerForRefresh = true,
	registerForDefaults = true,
	resetFunc = function() LucysCompass_RevertAll() end,
}


--Submenus
local record = {
		--Entries
		[1] = {
			type = "header",
			name = langpack.settings1,
			width = "full"
		},					
		[2] = {
			type = "checkbox",
			name = langpack.plant,
			tooltip = langpack.search..langpack.plant..".",
			getFunc = function() return LucysCompass_Plant end,
			setFunc = function() LucysCompass_TogglePlant() end,
		},	
		[3] = {
			type = "checkbox",
			name = langpack.water,
			tooltip = langpack.search..langpack.water..".",
			getFunc = function() return LucysCompass_Water end,
			setFunc = function() LucysCompass_ToggleWater() end,
		},			
		[4] = {
			type = "checkbox",
			name = langpack.rune,
			tooltip = langpack.search..langpack.rune..".",
			getFunc = function() return LucysCompass_Rune end,
			setFunc = function() LucysCompass_ToggleRune() end,
		},		
		[5] = {
			type = "checkbox",
			name = langpack.wood,
			tooltip = langpack.search..langpack.wood..".",
			getFunc = function() return LucysCompass_Wood end,
			setFunc = function() LucysCompass_ToggleWood() end,
		},	
		[6] = {
			type = "checkbox",
			name = langpack.ore,
			tooltip = langpack.search..langpack.ore..".",
			getFunc = function() return LucysCompass_Ore end,
			setFunc = function() LucysCompass_ToggleOre() end,
		},				
		[7] = {
			type = "checkbox",
			name = langpack.cloth,
			tooltip = langpack.search..langpack.cloth..".",
			getFunc = function() return LucysCompass_Cloth end,
			setFunc = function() LucysCompass_ToggleCloth() end,
		},	
		[8] = {
			type = "checkbox",
			name = langpack.treasure,
			tooltip = langpack.search..langpack.treasure..".",
			getFunc = function() return LucysCompass_Treasure end,
			setFunc = function() LucysCompass_ToggleTreasure() end,
		},		
		[9] = {
			type = "checkbox",
			name = langpack.rall1,
			tooltip = langpack.rall2,
			getFunc = function() return LucysCompass_RecordAll end,
			setFunc = function() LucysCompass_RecordAll() end,
		},		
		[10] = {
			type = "checkbox",
			name = langpack.hide1,
			tooltip = langpack.hide2,
			getFunc = function() return hidden end,
			setFunc = function() LucysCompass_ToggleHide() end,
		}
	
}


local display = {
		--Entries
		[1] = {
			type = "header",
			name = langpack.settings2,
			width = "full"
		},
		[2] = {
			type = "checkbox",
			name = langpack.thievery1,
			tooltip = langpack.thievery2,
			getFunc = function() return LucysCompass_Thievery end,
			setFunc = function() LucysCompass_toggleThievery() end,
		},
		[3] = {
			type = "checkbox",
			name = langpack.exploration1,
			tooltip = langpack.exploration2,
			getFunc = function() return LucysCompass_Exploration end,
			setFunc = function() LucysCompass_toggleExploration() end,
		}
	
}



local settings = {
		--Entries
		[1] = {
			type = "header",
			name = langpack.settings3,
			width = "full"
		},
		[2] = {
			type = "slider",
			name = langpack.settingsignore1,
			tooltip = langpack.settingsignore2,
			min = 1,
			max = 20,
			step = 1,
			getFunc = function() return LucysCompass_maxRecently end,
			setFunc = function(value) LucysCompass_SetRecently(value) end
		},			
		[3] = {
			type = "slider",
			name = langpack.settingssize1,
			tooltip = langpack.settingssize2,
			min = 1,
			max = 5,
			step = 1,
			getFunc = function() return LucysCompass_nodeSize*1000 end,
			setFunc = function(value) LucysCompass_SetNodeSize(value) end
		},
		[4] = {
			type = "checkbox",
			name = langpack.intelligentscaletitle,
			tooltip = langpack.intelligentscaletooltip,
			getFunc = function() return LucysCompass_IntelligentScaling end,
			setFunc = function() LucysCompass_toggleIntelligentScaling() end,
		},
	
}

local lbProfiles, pText = LucysCompass_getUserData()
local lbGathering, gText = LucysCompass_getGatheringData()
local lbMaps,mTexts = LucysCompass_sortDataByMap()

local storage = {
		--Entries
		[1] = {
			type = "header",
			name = langpack.dataheader,
			width = "full"
		},
		[2] = {
			type = "button",
			name = langpack.reload,
			func = function() ReloadUI()  end,
			width = "half",
		}
}
local tableEntry_gathering = {
			type = "description",
			title = langpack.datagathering,
			text = gText
		}
local tableEntryTitle_map = {
			type = "description",
			title = langpack.datamaps,
			text = mTexts[1].title.."\n"..mTexts[1].text
		}
local tableEntry_profiles = {
			type = "description",
			title = langpack.dataprofiles,
			text = pText
		}
local tableEntry_spacer = {
			type = "description",
			text = "\n\n\n\n\n"
		}
local tableEntry_spacer_short = {
			type = "description",
			text = "\n\n"
		}
local tableEntry_endnote = {
			type = "description",
			title = langpack.deleteallinfo,
			text = langpack.deleteallheader
		}
--construct
table.insert(storage,tableEntry_gathering)
for i=1,lbGathering do
	table.insert(storage,tableEntry_spacer)
end
table.insert(storage,tableEntryTitle_map)
for i=2,lbMaps do
	tableEntry_map = {
			type = "description",
			text = mTexts[i].title.."\n"..mTexts[i].text
		}
	table.insert(storage,tableEntry_map)
end
table.insert(storage,tableEntry_spacer_short)
table.insert(storage,tableEntry_profiles)
for i=1,lbProfiles do
	table.insert(storage,tableEntry_spacer)
end
table.insert(storage,tableEntry_endnote)
	
local LC_LAM = LibStub:GetLibrary('LibAddonMenu-2.0')
LC_LAM:RegisterAddonPanel("LucysCompass", panel_settings)

pointer = 0

local data_settings = {}

for i = 1, #record do
	pointer = pointer + 1
	data_settings[pointer] = record[i]	
end
for i = 1, #display do
	pointer = pointer + 1
	data_settings[pointer] = display[i]	
end
for i = 1, #settings do
	pointer = pointer + 1
	data_settings[pointer] = settings[i]	
end
for i = 1, #storage do
	pointer = pointer + 1
	data_settings[pointer] = storage[i]	
end

LC_LAM:RegisterOptionControls("LucysCompass", data_settings)
end
